=== debian/changelog ===
libsoundio (1.0.2-2) unstable; urgency=medium

  * QA upload.
  * Orphan package, set maintainer to qa group

 -- Felipe Sateler <fsateler@debian.org>  Sat, 29 Sep 2018 19:20:09 -0300

libsoundio (1.0.2-1) unstable; urgency=medium

  * Update to upstream version 1.0.2.
  * Add arch independent endian detection patch from upstream.
    (Closes: #799335)

 -- Andrew Kelley <superjoe30@gmail.com>  Thu, 24 Sep 2015 09:55:14 -0700

libsoundio (1.0.1-1) unstable; urgency=medium

  * Initial release. (Closes: #798735)

 -- Andrew Kelley <superjoe30@gmail.com>  Fri, 11 Sep 2015 22:29:01 -0700
