=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_strip:
	dh_strip --dbg-package=libsoundio-dbg

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md
