=== debian/changelog ===
libsoundio (1.1.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Adrian Bunk <bunk@debian.org>  Wed, 20 Nov 2019 22:04:00 +0200

libsoundio (1.0.2-3) unstable; urgency=medium

  * QA upload.

  [ Jelmer Vernooĳ ]
  * Transition to automatic debug package (from: libsoundio-dbg).

  [ Sebastian Ramacher ]
  * debian/: Bump debhelper compat to 12.
  * debian/control:
    - Bump Standards-Version.
    - Remove obsolete Pre-Depends.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 07 Jul 2019 13:08:55 +0200
