=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Maintainer: Debian QA Group <packages@qa.debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                doxygen,
                libasound2-dev,
                libjack-jackd2-dev,
                libpulse-dev,
                pkg-config
-Standards-Version: 3.9.6
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/multimedia-team/libsoundio
 Vcs-Git: https://salsa.debian.org/multimedia-team/libsoundio.git
 Homepage: http://libsound.io/
@@ -39,7 +39,6 @@
 Multi-Arch: same
 Depends: ${shlibs:Depends},
          ${misc:Depends}
-Pre-Depends: ${misc:Pre-Depends}
 Description: cross-platform audio input and output library
  libsoundio is a lightweight abstraction over various sound drivers. It provides
  a well-documented API that operates consistently regardless of the sound driver
@@ -53,12 +52,3 @@
  conditions correctly.
  .
  This package contains the shared library.
-
-Package: libsoundio-dbg
-Architecture: any
-Multi-Arch: same
-Section: debug
-Depends: libsoundio1 (= ${binary:Version}),
-         ${misc:Depends}
-Description: debugging symbols for libsoundio
- This package contains the debugging symbols for libsoundio1.
