=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	dh $@
 
 override_dh_strip:
-	dh_strip --dbg-package=libsoundio-dbg
+	dh_strip --dbgsym-migration='libsoundio-dbg (<< 1.0.2-3~)'
 
 override_dh_installchangelogs:
 	dh_installchangelogs -k CHANGELOG.md
