=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/libsoundio-$1.tar.gz/ \
 https://github.com/andrewrk/libsoundio/tags .*/archive/v?([\d\.]+).tar.gz
