## libsoundio 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.8.5)
 project(libsoundio C)
-set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
+set(CMAKE_MODULE_PATH ${libsoundio_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
 
 if(CMAKE_VERSION VERSION_LESS 3.0.0)
     set(CMAKE_INSTALL_LIBDIR "lib" CACHE PATH "library install dir (lib)")
@@ -17,13 +17,18 @@
       "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
 endif()
 
-set(LIBSOUNDIO_VERSION_MAJOR 1)
-set(LIBSOUNDIO_VERSION_MINOR 1)
+set(LIBSOUNDIO_VERSION_MAJOR 2)
+set(LIBSOUNDIO_VERSION_MINOR 0)
 set(LIBSOUNDIO_VERSION_PATCH 0)
 set(LIBSOUNDIO_VERSION "${LIBSOUNDIO_VERSION_MAJOR}.${LIBSOUNDIO_VERSION_MINOR}.${LIBSOUNDIO_VERSION_PATCH}")
 message("Configuring libsoundio version ${LIBSOUNDIO_VERSION}")
 
+if(NOT SOUNDIO_STATIC_LIBNAME)
+    set(SOUNDIO_STATIC_LIBNAME soundio)
+endif()
+
 option(BUILD_STATIC_LIBS "Build static libraries" ON)
+option(BUILD_DYNAMIC_LIBS "Build dynamic libraries" ON)
 option(BUILD_EXAMPLE_PROGRAMS "Build example programs" ON)
 option(BUILD_TESTS "Build tests" ON)
 option(ENABLE_JACK "Enable JACK backend" ON)
@@ -135,51 +140,51 @@
 
 
 set(LIBSOUNDIO_SOURCES
-    "${CMAKE_SOURCE_DIR}/src/soundio.c"
-    "${CMAKE_SOURCE_DIR}/src/util.c"
-    "${CMAKE_SOURCE_DIR}/src/os.c"
-    "${CMAKE_SOURCE_DIR}/src/dummy.c"
-    "${CMAKE_SOURCE_DIR}/src/channel_layout.c"
-    "${CMAKE_SOURCE_DIR}/src/ring_buffer.c"
-)
-
-set(CONFIGURE_OUT_FILE "${CMAKE_BINARY_DIR}/config.h")
+    "${libsoundio_SOURCE_DIR}/src/soundio.c"
+    "${libsoundio_SOURCE_DIR}/src/util.c"
+    "${libsoundio_SOURCE_DIR}/src/os.c"
+    "${libsoundio_SOURCE_DIR}/src/dummy.c"
+    "${libsoundio_SOURCE_DIR}/src/channel_layout.c"
+    "${libsoundio_SOURCE_DIR}/src/ring_buffer.c"
+)
+
+set(CONFIGURE_OUT_FILE "${libsoundio_BINARY_DIR}/config.h")
 set(LIBSOUNDIO_HEADERS
-    "${CMAKE_SOURCE_DIR}/soundio/soundio.h"
-    "${CMAKE_SOURCE_DIR}/soundio/endian.h"
+    "${libsoundio_SOURCE_DIR}/soundio/soundio.h"
+    "${libsoundio_SOURCE_DIR}/soundio/endian.h"
 )
 
 if(SOUNDIO_HAVE_JACK)
     set(LIBSOUNDIO_SOURCES ${LIBSOUNDIO_SOURCES}
-        "${CMAKE_SOURCE_DIR}/src/jack.c"
+        "${libsoundio_SOURCE_DIR}/src/jack.c"
     )
 endif()
 if(SOUNDIO_HAVE_PULSEAUDIO)
     set(LIBSOUNDIO_SOURCES ${LIBSOUNDIO_SOURCES}
-        "${CMAKE_SOURCE_DIR}/src/pulseaudio.c"
+        "${libsoundio_SOURCE_DIR}/src/pulseaudio.c"
     )
 endif()
 if(SOUNDIO_HAVE_ALSA)
     set(LIBSOUNDIO_SOURCES ${LIBSOUNDIO_SOURCES}
-        "${CMAKE_SOURCE_DIR}/src/alsa.c"
+        "${libsoundio_SOURCE_DIR}/src/alsa.c"
     )
 endif()
 if(SOUNDIO_HAVE_COREAUDIO)
     set(LIBSOUNDIO_SOURCES ${LIBSOUNDIO_SOURCES}
-        "${CMAKE_SOURCE_DIR}/src/coreaudio.c"
+        "${libsoundio_SOURCE_DIR}/src/coreaudio.c"
     )
 endif()
 if(SOUNDIO_HAVE_WASAPI)
     set(LIBSOUNDIO_SOURCES ${LIBSOUNDIO_SOURCES}
-        "${CMAKE_SOURCE_DIR}/src/wasapi.c"
+        "${libsoundio_SOURCE_DIR}/src/wasapi.c"
     )
 endif()
 
 include_directories(
-    ${CMAKE_SOURCE_DIR}
-    ${CMAKE_BINARY_DIR}
-    "${CMAKE_SOURCE_DIR}/test"
-    "${CMAKE_SOURCE_DIR}/src"
+    ${libsoundio_SOURCE_DIR}
+    ${libsoundio_BINARY_DIR}
+    "${libsoundio_SOURCE_DIR}/test"
+    "${libsoundio_SOURCE_DIR}/src"
 )
 
 set(LIBSOUNDIO_LIBS
@@ -192,42 +197,49 @@
     ${CMAKE_THREAD_LIBS_INIT}
 )
 
-
-
-set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Werror -pedantic")
-
-
-set(LIB_CFLAGS "-std=c11 -fvisibility=hidden -Wall -Werror=strict-prototypes -Werror=old-style-definition -Werror=missing-prototypes -D_REENTRANT -D_POSIX_C_SOURCE=200809L")
-set(EXAMPLE_CFLAGS "-std=c99 -Wall")
-set(TEST_CFLAGS "${LIB_CFLAGS} -fprofile-arcs -ftest-coverage")
-set(TEST_LDFLAGS "-fprofile-arcs -ftest-coverage")
+if(MSVC)
+    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /Wall")
+    set(LIB_CFLAGS "/TP /W4")
+    set(EXAMPLE_CFLAGS "/W4")
+    set(TEST_CFLAGS "${LIB_CFLAGS}")
+    set(TEST_LDFLAGS " ")
+    set(LIBM " ")
+else()
+    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Werror -pedantic")
+    set(LIB_CFLAGS "-std=c11 -fvisibility=hidden -Wall -Werror=strict-prototypes -Werror=old-style-definition -Werror=missing-prototypes -D_REENTRANT -D_POSIX_C_SOURCE=200809L -Wno-missing-braces")
+    set(EXAMPLE_CFLAGS "-std=c99 -Wall")
+    set(TEST_CFLAGS "${LIB_CFLAGS} -fprofile-arcs -ftest-coverage")
+    set(TEST_LDFLAGS "-fprofile-arcs -ftest-coverage")
+    set(LIBM "m")
+endif()
 
 configure_file(
-    "${CMAKE_SOURCE_DIR}/src/config.h.in"
+    "${libsoundio_SOURCE_DIR}/src/config.h.in"
     ${CONFIGURE_OUT_FILE}
 )
-set(DOXYGEN_CONF_FILE "${CMAKE_BINARY_DIR}/doxygen.conf")
+set(DOXYGEN_CONF_FILE "${libsoundio_BINARY_DIR}/doxygen.conf")
 configure_file(
-    "${CMAKE_SOURCE_DIR}/doc/doxygen.conf.in"
+    "${libsoundio_SOURCE_DIR}/doc/doxygen.conf.in"
     ${DOXYGEN_CONF_FILE}
 )
 
-add_library(libsoundio_shared SHARED ${LIBSOUNDIO_SOURCES})
-set_target_properties(libsoundio_shared PROPERTIES
-    OUTPUT_NAME soundio
-    SOVERSION ${LIBSOUNDIO_VERSION_MAJOR}
-    VERSION ${LIBSOUNDIO_VERSION}
-    COMPILE_FLAGS ${LIB_CFLAGS}
-    LINKER_LANGUAGE C
-)
-target_link_libraries(libsoundio_shared LINK_PUBLIC ${LIBSOUNDIO_LIBS})
-install(TARGETS libsoundio_shared DESTINATION ${CMAKE_INSTALL_LIBDIR})
-
+if(BUILD_DYNAMIC_LIBS)
+    add_library(libsoundio_shared SHARED ${LIBSOUNDIO_SOURCES})
+    set_target_properties(libsoundio_shared PROPERTIES
+        OUTPUT_NAME soundio
+        SOVERSION ${LIBSOUNDIO_VERSION_MAJOR}
+        VERSION ${LIBSOUNDIO_VERSION}
+        COMPILE_FLAGS ${LIB_CFLAGS}
+        LINKER_LANGUAGE C
+    )
+    target_link_libraries(libsoundio_shared LINK_PUBLIC ${LIBSOUNDIO_LIBS})
+    install(TARGETS libsoundio_shared DESTINATION ${CMAKE_INSTALL_LIBDIR})
+endif()
 
 if(BUILD_STATIC_LIBS)
     add_library(libsoundio_static STATIC ${LIBSOUNDIO_SOURCES})
     set_target_properties(libsoundio_static PROPERTIES
-        OUTPUT_NAME soundio
+        OUTPUT_NAME ${SOUNDIO_STATIC_LIBNAME}
         COMPILE_FLAGS ${LIB_CFLAGS}
         LINKER_LANGUAGE C
     )
@@ -245,33 +257,49 @@
     set_target_properties(sio_sine PROPERTIES
         LINKER_LANGUAGE C
         COMPILE_FLAGS ${EXAMPLE_CFLAGS})
-    target_link_libraries(sio_sine libsoundio_shared m)
+    if(BUILD_DYNAMIC_LIBS)
+        target_link_libraries(sio_sine libsoundio_shared ${LIBM})
+    else()
+        target_link_libraries(sio_sine libsoundio_static ${LIBSOUNDIO_LIBS} ${LIBM})
+    endif()
     install(TARGETS sio_sine DESTINATION ${CMAKE_INSTALL_BINDIR})
 
     add_executable(sio_list_devices example/sio_list_devices.c)
     set_target_properties(sio_list_devices PROPERTIES
         LINKER_LANGUAGE C
         COMPILE_FLAGS ${EXAMPLE_CFLAGS})
-    target_link_libraries(sio_list_devices libsoundio_shared)
+    if(BUILD_DYNAMIC_LIBS)
+        target_link_libraries(sio_list_devices libsoundio_shared)
+    else()
+        target_link_libraries(sio_list_devices libsoundio_static ${LIBSOUNDIO_LIBS})
+    endif()
     install(TARGETS sio_list_devices DESTINATION ${CMAKE_INSTALL_BINDIR})
 
     add_executable(sio_microphone example/sio_microphone.c)
     set_target_properties(sio_microphone PROPERTIES
         LINKER_LANGUAGE C
         COMPILE_FLAGS ${EXAMPLE_CFLAGS})
-    target_link_libraries(sio_microphone libsoundio_shared)
+    if(BUILD_DYNAMIC_LIBS)
+        target_link_libraries(sio_microphone libsoundio_shared)
+    else()
+        target_link_libraries(sio_microphone libsoundio_static ${LIBSOUNDIO_LIBS})
+    endif()
     install(TARGETS sio_microphone DESTINATION ${CMAKE_INSTALL_BINDIR})
 
     add_executable(sio_record example/sio_record.c)
     set_target_properties(sio_record PROPERTIES
         LINKER_LANGUAGE C
         COMPILE_FLAGS ${EXAMPLE_CFLAGS})
-    target_link_libraries(sio_record libsoundio_shared)
+    if(BUILD_DYNAMIC_LIBS)
+        target_link_libraries(sio_record libsoundio_shared)
+    else()
+        target_link_libraries(sio_record libsoundio_static ${LIBSOUNDIO_LIBS})
+    endif()
     install(TARGETS sio_record DESTINATION ${CMAKE_INSTALL_BINDIR})
 endif()
 
 if(BUILD_TESTS)
-    add_executable(unit_tests "${CMAKE_SOURCE_DIR}/test/unit_tests.c" ${LIBSOUNDIO_SOURCES})
+    add_executable(unit_tests "${libsoundio_SOURCE_DIR}/test/unit_tests.c" ${LIBSOUNDIO_SOURCES})
     target_link_libraries(unit_tests LINK_PUBLIC ${LIBSOUNDIO_LIBS})
     set_target_properties(unit_tests PROPERTIES
         LINKER_LANGUAGE C
@@ -279,8 +307,8 @@
         LINK_FLAGS ${TEST_LDFLAGS}
     )
 
-    add_executable(latency "${CMAKE_SOURCE_DIR}/test/latency.c" ${LIBSOUNDIO_SOURCES})
-    target_link_libraries(latency LINK_PUBLIC ${LIBSOUNDIO_LIBS} m)
+    add_executable(latency "${libsoundio_SOURCE_DIR}/test/latency.c" ${LIBSOUNDIO_SOURCES})
+    target_link_libraries(latency LINK_PUBLIC ${LIBSOUNDIO_LIBS} ${LIBM})
     set_target_properties(latency PROPERTIES
         LINKER_LANGUAGE C
         COMPILE_FLAGS ${LIB_CFLAGS}
@@ -290,25 +318,37 @@
     set_target_properties(underflow PROPERTIES
         LINKER_LANGUAGE C
         COMPILE_FLAGS ${EXAMPLE_CFLAGS})
-    target_link_libraries(underflow libsoundio_shared m)
+    if(BUILD_DYNAMIC_LIBS)
+        target_link_libraries(underflow libsoundio_shared ${LIBM})
+    else()
+        target_link_libraries(underflow libsoundio_static ${LIBSOUNDIO_LIBS} ${LIBM})
+    endif()
 
     add_executable(backend_disconnect_recover test/backend_disconnect_recover.c)
     set_target_properties(backend_disconnect_recover PROPERTIES
         LINKER_LANGUAGE C
         COMPILE_FLAGS ${EXAMPLE_CFLAGS})
-    target_link_libraries(backend_disconnect_recover libsoundio_shared)
+    if(BUILD_DYNAMIC_LIBS)
+        target_link_libraries(backend_disconnect_recover libsoundio_shared)
+    else()
+        target_link_libraries(backend_disconnect_recover libsoundio_static ${LIBSOUNDIO_LIBS})
+    endif()
 
     add_executable(overflow test/overflow.c)
     set_target_properties(overflow PROPERTIES
         LINKER_LANGUAGE C
         COMPILE_FLAGS ${EXAMPLE_CFLAGS})
-    target_link_libraries(overflow libsoundio_shared)
+    if(BUILD_DYNAMIC_LIBS)
+        target_link_libraries(overflow libsoundio_shared)
+    else()
+        target_link_libraries(overflow libsoundio_static ${LIBSOUNDIO_LIBS})
+    endif()
 
 
 
     add_custom_target(coverage
         DEPENDS unit_tests
-        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+        WORKING_DIRECTORY ${libsoundio_BINARY_DIR}
         COMMAND lcov --directory . --zerocounters --rc lcov_branch_coverage=1
         COMMAND ./unit_tests
         COMMAND lcov --directory . --capture --output-file coverage.info --rc lcov_branch_coverage=1
@@ -320,7 +360,7 @@
 
 
 add_custom_target(doc
-    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+    WORKING_DIRECTORY ${libsoundio_BINARY_DIR}
     COMMAND doxygen ${DOXYGEN_CONF_FILE}
 )
 
@@ -329,20 +369,3 @@
 message("\n"
     "Installation Summary\n"
     "--------------------\n"
-    "* Install Directory            : ${CMAKE_INSTALL_PREFIX}\n"
-    "* Build Type                   : ${CMAKE_BUILD_TYPE}\n"
-    "* Build static libs            : ${BUILD_STATIC_LIBS}\n"
-    "* Build examples               : ${BUILD_EXAMPLE_PROGRAMS}\n"
-    "* Build tests                  : ${BUILD_TESTS}\n"
-)
-
-message(
-    "System Dependencies\n"
-    "-------------------\n"
-    "* threads                      : ${STATUS_THREADS}\n"
-    "* JACK       (optional)        : ${STATUS_JACK}\n"
-    "* PulseAudio (optional)        : ${STATUS_PULSEAUDIO}\n"
-    "* ALSA       (optional)        : ${STATUS_ALSA}\n"
-    "* CoreAudio  (optional)        : ${STATUS_COREAUDIO}\n"
-    "* WASAPI     (optional)        : ${STATUS_WASAPI}\n"
-)
