=== debian/changelog ===
libsoundio (2.0.0-3) unstable; urgency=medium

  * Team upload.
  * Update build for CMake 4 (Closes: #1113202)
  * Update B-D on pkg-config to pkgconf
  * Update debian/watch to version 5
  * Add Build-Depends-Package: libsoundio-dev metadata to libsoundio2.symbols
  * Bump Standards-Version to 4.7.2

 -- tony mancill <tmancill@debian.org>  Sun, 19 Oct 2025 15:20:51 -0700

libsoundio (2.0.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Christoph Berg <myon@debian.org>  Fri, 11 Mar 2022 11:16:01 +0100

libsoundio (2.0.0-1) experimental; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.0, no changes needed.

  [ Christoph Berg ]
  * Fix watch file to see github tarballs.
  * New upstream version 2.0.0; bump soname to libsoundio2.
  * DH 13 and mark /usr/bin/sio_* as not-installed.
  * Drop dh_strip --dbgsym-migration code.
  * Add debian/gitlab-ci.yml.
  * Adopt package under the Debian Hamradio Team umbrella. (Closes: #909881)

 -- Christoph Berg <myon@debian.org>  Sun, 25 Apr 2021 23:39:11 +0200
