=== debian/control ===
--- 
+++ 
@@ -1,25 +1,29 @@
 Source: libsoundio
-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
+Uploaders:
+ Christoph Berg <myon@debian.org>,
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
-               cmake,
-               doxygen,
-               libasound2-dev,
-               libjack-jackd2-dev,
-               libpulse-dev,
-               pkg-config
-Standards-Version: 4.3.0
-Vcs-Browser: https://salsa.debian.org/multimedia-team/libsoundio
-Vcs-Git: https://salsa.debian.org/multimedia-team/libsoundio.git
+Build-Depends:
+ cmake,
+ debhelper-compat (= 13),
+ doxygen,
+ libasound2-dev,
+ libjack-jackd2-dev,
+ libpulse-dev,
+ pkgconf,
+Standards-Version: 4.7.2
+Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/libsoundio
+Vcs-Git: https://salsa.debian.org/debian-hamradio-team/libsoundio.git
 Homepage: http://libsound.io/
 
 Package: libsoundio-dev
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libsoundio1 (= ${binary:Version}),
-         ${misc:Depends}
+Depends:
+ libsoundio2 (= ${binary:Version}),
+ ${misc:Depends},
 Description: cross platform audio input and output library (development files)
  libsoundio is a lightweight abstraction over various sound drivers. It provides
  a well-documented API that operates consistently regardless of the sound driver
@@ -34,11 +38,12 @@
  .
  This package contains the development files.
 
-Package: libsoundio1
+Package: libsoundio2
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends},
-         ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: cross-platform audio input and output library
  libsoundio is a lightweight abstraction over various sound drivers. It provides
  a well-documented API that operates consistently regardless of the sound driver
