=== debian/watch ===
Version: 5

Source: https://github.com/andrewrk/libsoundio/tags
Matching-Pattern: .*/v?([\d\.]+).tar.gz
Dversionmangle: s/\+(debian|dfsg|ds|deb)(\.\d+)?$//
Filenamemangle: s/.*\/v?([\d\.-]+)\.tar\.gz/libsoundio-$1.tar.gz/
